SDL_joystick.h File Reference
`#include "SDL_stdinc.h"`
`#include "SDL_error.h"`
`#include "begin_code.h"`
`#include "close_code.h"`
Include dependency graph for SDL_joystick.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

struct | SDL_JoystickGUID

## Macros

#define | SDL_JOYSTICK_AXIS_MAX 32767
#define | SDL_JOYSTICK_AXIS_MIN -32768
Hat positions
#define | SDL_HAT_CENTERED 0x00
#define | SDL_HAT_UP 0x01
#define | SDL_HAT_RIGHT 0x02
#define | SDL_HAT_DOWN 0x04
#define | SDL_HAT_LEFT 0x08
#define | SDL_HAT_RIGHTUP (SDL_HAT_RIGHT|SDL_HAT_UP)
#define | SDL_HAT_RIGHTDOWN (SDL_HAT_RIGHT|SDL_HAT_DOWN)
#define | SDL_HAT_LEFTUP (SDL_HAT_LEFT|SDL_HAT_UP)
#define | SDL_HAT_LEFTDOWN (SDL_HAT_LEFT|SDL_HAT_DOWN)

## Typedefs

typedef Sint32 | SDL_JoystickID

## Enumerations

enum | SDL_JoystickType { SDL_JOYSTICK_TYPE_UNKNOWN, SDL_JOYSTICK_TYPE_GAMECONTROLLER, SDL_JOYSTICK_TYPE_WHEEL, SDL_JOYSTICK_TYPE_ARCADE_STICK, SDL_JOYSTICK_TYPE_FLIGHT_STICK, SDL_JOYSTICK_TYPE_DANCE_PAD, SDL_JOYSTICK_TYPE_GUITAR, SDL_JOYSTICK_TYPE_DRUM_KIT, SDL_JOYSTICK_TYPE_ARCADE_PAD, SDL_JOYSTICK_TYPE_THROTTLE }
enum | SDL_JoystickPowerLevel { SDL_JOYSTICK_POWER_UNKNOWN = -1, SDL_JOYSTICK_POWER_EMPTY, SDL_JOYSTICK_POWER_LOW, SDL_JOYSTICK_POWER_MEDIUM, SDL_JOYSTICK_POWER_FULL, SDL_JOYSTICK_POWER_WIRED, SDL_JOYSTICK_POWER_MAX }

## Functions

void | SDL_LockJoysticks (void)
void | SDL_UnlockJoysticks (void)
int | SDL_NumJoysticks (void)
const char * | SDL_JoystickNameForIndex (int device_index)
SDL_JoystickGUID | SDL_JoystickGetDeviceGUID (int device_index)
Uint16 | SDL_JoystickGetDeviceVendor (int device_index)
Uint16 | SDL_JoystickGetDeviceProduct (int device_index)
Uint16 | SDL_JoystickGetDeviceProductVersion (int device_index)
SDL_JoystickType | SDL_JoystickGetDeviceType (int device_index)
SDL_JoystickID | SDL_JoystickGetDeviceInstanceID (int device_index)
SDL_Joystick * | SDL_JoystickOpen (int device_index)
SDL_Joystick * | SDL_JoystickFromInstanceID (SDL_JoystickID joyid)
const char * | SDL_JoystickName (SDL_Joystick *joystick)
SDL_JoystickGUID | SDL_JoystickGetGUID (SDL_Joystick *joystick)
Uint16 | SDL_JoystickGetVendor (SDL_Joystick *joystick)
Uint16 | SDL_JoystickGetProduct (SDL_Joystick *joystick)
Uint16 | SDL_JoystickGetProductVersion (SDL_Joystick *joystick)
SDL_JoystickType | SDL_JoystickGetType (SDL_Joystick *joystick)
void | SDL_JoystickGetGUIDString (SDL_JoystickGUID guid, char *pszGUID, int cbGUID)
SDL_JoystickGUID | SDL_JoystickGetGUIDFromString (const char *pchGUID)
SDL_bool | SDL_JoystickGetAttached (SDL_Joystick *joystick)
SDL_JoystickID | SDL_JoystickInstanceID (SDL_Joystick *joystick)
int | SDL_JoystickNumAxes (SDL_Joystick *joystick)
int | SDL_JoystickNumBalls (SDL_Joystick *joystick)
int | SDL_JoystickNumHats (SDL_Joystick *joystick)
int | SDL_JoystickNumButtons (SDL_Joystick *joystick)
void | SDL_JoystickUpdate (void)
int | SDL_JoystickEventState (int state)
Sint16 | SDL_JoystickGetAxis (SDL_Joystick *joystick, int axis)
SDL_bool | SDL_JoystickGetAxisInitialState (SDL_Joystick *joystick, int axis, Sint16 *state)
Uint8 | SDL_JoystickGetHat (SDL_Joystick *joystick, int hat)
int | SDL_JoystickGetBall (SDL_Joystick *joystick, int ball, int *dx, int *dy)
Uint8 | SDL_JoystickGetButton (SDL_Joystick *joystick, int button)
void | SDL_JoystickClose (SDL_Joystick *joystick)
SDL_JoystickPowerLevel | SDL_JoystickCurrentPowerLevel (SDL_Joystick *joystick)

## Detailed Description

Include file for SDL joystick event handling

The term "device_index" identifies currently plugged in joystick devices between 0 and SDL_NumJoysticks(), with the exact joystick behind a device_index changing as joysticks are plugged and unplugged.

The term "instance_id" is the current instantiation of a joystick device in the system, if the joystick is removed and then re-inserted then it will get a new instance_id, instance_id's are monotonically increasing identifiers of a joystick plugged in.

The term JoystickGUID is a stable 128-bit identifier for a joystick device that does not change over time, it identifies class of the device (a X360 wired controller for example). This identifier is platform dependent.

In order to use these functions, SDL_Init() must have been called with the SDL_INIT_JOYSTICK flag. This causes SDL to scan the system for joysticks, and load appropriate drivers.

If you would like to receive joystick updates while the application is in the background, you should set the following hint before calling SDL_Init(): SDL_HINT_JOYSTICK_ALLOW_BACKGROUND_EVENTS

Definition in file SDL_joystick.h.

## Macro Definition Documentation

## SDL_HAT_CENTERED

#define SDL_HAT_CENTERED 0x00

Definition at line 316 of file SDL_joystick.h.

Referenced by loop(), SDL_JoystickUpdate(), SDL_PrivateJoystickHat(), SDL_SYS_AccelerometerUpdate(), SDL_SYS_MFIJoystickUpdate(), SDLTest_PrintEvent(), and WatchJoystick().

## SDL_HAT_DOWN

#define SDL_HAT_DOWN 0x04

Definition at line 319 of file SDL_joystick.h.

Referenced by loop(), SDL_SYS_AccelerometerUpdate(), and SDLTest_PrintEvent().

## SDL_HAT_LEFT

#define SDL_HAT_LEFT 0x08

Definition at line 320 of file SDL_joystick.h.

Referenced by loop(), SDL_SYS_AccelerometerUpdate(), and SDLTest_PrintEvent().

## SDL_HAT_LEFTDOWN

#define SDL_HAT_LEFTDOWN (SDL_HAT_LEFT|SDL_HAT_DOWN)

Definition at line 324 of file SDL_joystick.h.

Referenced by SDLTest_PrintEvent().

## SDL_HAT_LEFTUP

#define SDL_HAT_LEFTUP (SDL_HAT_LEFT|SDL_HAT_UP)

Definition at line 323 of file SDL_joystick.h.

Referenced by SDLTest_PrintEvent().

## SDL_HAT_RIGHT

#define SDL_HAT_RIGHT 0x02

Definition at line 318 of file SDL_joystick.h.

Referenced by loop(), SDL_SYS_AccelerometerUpdate(), and SDLTest_PrintEvent().

## SDL_HAT_RIGHTDOWN

#define SDL_HAT_RIGHTDOWN (SDL_HAT_RIGHT|SDL_HAT_DOWN)

Definition at line 322 of file SDL_joystick.h.

Referenced by SDLTest_PrintEvent().

## SDL_HAT_RIGHTUP

#define SDL_HAT_RIGHTUP (SDL_HAT_RIGHT|SDL_HAT_UP)

Definition at line 321 of file SDL_joystick.h.

Referenced by SDLTest_PrintEvent().

## SDL_HAT_UP

#define SDL_HAT_UP 0x01

Definition at line 317 of file SDL_joystick.h.

Referenced by loop(), SDL_SYS_AccelerometerUpdate(), and SDLTest_PrintEvent().

## SDL_JOYSTICK_AXIS_MAX

#define SDL_JOYSTICK_AXIS_MAX 32767

Definition at line 288 of file SDL_joystick.h.

Referenced by SDL_PrivateGameControllerParseElement(), SDL_PrivateJoystickAxis(), StandardizeAxisValue(), and WatchJoystick().

## SDL_JOYSTICK_AXIS_MIN

#define SDL_JOYSTICK_AXIS_MIN -32768

Definition at line 289 of file SDL_joystick.h.

Referenced by SDL_PrivateGameControllerParseElement(), StandardizeAxisValue(), and WatchJoystick().

## Typedef Documentation

## SDL_JoystickID

SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char const char SDL_SCANF_FORMAT_STRING const char return SDL_ThreadFunction const char void return Uint32 return Uint32 SDL_AssertionHandler void SDL_SpinLock SDL_atomic_t int int return SDL_atomic_t return void void void return void return int return SDL_AudioSpec SDL_AudioSpec return int int return return int SDL_RWops int SDL_AudioSpec Uint8 Uint32 return SDL_AudioCVT SDL_AudioFormat Uint8 int SDL_AudioFormat Uint8 int return Uint8 const Uint8 Uint32 int const char return return return return return return return return Uint32 return Uint32 SDL_Event return SDL_Event int return SDL_EventFilter void SDL_EventFilter void SDL_EventFilter void int return const char const char return SDL_JoystickGUID return int return int return SDL_GameController return int return const char return SDL_GameController SDL_GameControllerAxis return const char return SDL_GameController SDL_GameControllerButton return SDL_GameController SDL_RWops return SDL_TouchID SDL_RWops return int return int return return SDL_Joystick return SDL_Haptic SDL_Haptic return SDL_Haptic return SDL_Haptic SDL_HapticEffect return SDL_Haptic int Uint32 return SDL_Haptic int SDL_Haptic int return SDL_Haptic return SDL_Haptic return SDL_Haptic return SDL_Haptic return const char const char return const char SDL_HintCallback void int return SDL_Joystick return SDL_Joystick return const char return SDL_Joystick return SDL_Joystick return SDL_Joystick return int return SDL_Joystick int return SDL_Joystick int return return return SDL_Scancode return SDL_Scancode return SDL_Keycode return return const char return void int SDL_LogPriority SDL_LogOutputFunction void Uint32 const char const char SDL_Window return int int return SDL_Window int int return SDL_Surface int int return SDL_Cursor return int return SDL_mutex return SDL_mutex return Uint32 return SDL_sem return SDL_sem Uint32 return SDL_sem return SDL_cond SDL_cond return SDL_cond SDL_mutex Uint32 return Uint32 int Uint32 Uint32 Uint32 Uint32 return Uint32 return int return SDL_Palette const SDL_Color int int return const SDL_PixelFormat Uint8 Uint8 Uint8 return Uint32 const SDL_PixelFormat Uint8 Uint8 Uint8 float Uint16 int int return const SDL_Rect const SDL_Rect SDL_Rect return const SDL_Point int const SDL_Rect SDL_Rect return return int int Uint32 SDL_Window SDL_Renderer return SDL_Surface return SDL_Renderer SDL_RendererInfo return SDL_Renderer Uint32 int int int return SDL_Texture Uint32 int int int return SDL_Texture Uint8 Uint8 Uint8 return SDL_Texture Uint8 return SDL_Texture SDL_BlendMode return SDL_Texture const SDL_Rect const Uint8 int const Uint8 int const Uint8 int return SDL_Texture SDL_Renderer SDL_Texture return SDL_Renderer int int return SDL_Renderer const SDL_Rect return SDL_Renderer const SDL_Rect return SDL_Renderer float float return SDL_Renderer Uint8 Uint8 Uint8 Uint8 return SDL_Renderer SDL_BlendMode return SDL_Renderer return SDL_Renderer const SDL_Point int return SDL_Renderer const SDL_Point int return SDL_Renderer const SDL_Rect int return SDL_Renderer const SDL_Rect int return SDL_Renderer SDL_Texture const SDL_Rect const SDL_Rect const double const SDL_Point const SDL_RendererFlip return SDL_Renderer SDL_Renderer SDL_Texture return void int return return SDL_RWops return SDL_RWops return SDL_RWops return SDL_RWops return SDL_RWops Uint16 return SDL_RWops Uint32 return SDL_RWops Uint64 return const char unsigned int unsigned int unsigned int unsigned int Uint32 return SDL_Window SDL_Surface SDL_WindowShapeMode return size_t return void size_t return const char return void size_t size_t int(*) a int return int return int size_t return size_t return const wchar_t return const wchar_t size_t return const char size_t return const char size_t return char return char return const char int return int char int return long char int return Sint64 char int return const char return const char char int return const char char int return const char char return const char const char size_t return const char const char size_t return double return double return double return double return double return double return double int return float return const char const char return SDL_iconv_t const char size_t char size_t return Uint32 int int int Uint32 Uint32 Uint32 Uint32 return SDL_Surface SDL_Surface return SDL_RWops int return SDL_Surface int return SDL_Surface Uint32 return SDL_Surface Uint8 Uint8 Uint8 return SDL_Surface Uint8 return SDL_Surface SDL_BlendMode return SDL_Surface SDL_Rect SDL_Surface Uint32 Uint32 return SDL_Surface const SDL_Rect Uint32 return SDL_Surface const SDL_Rect SDL_Surface SDL_Rect return SDL_Surface const SDL_Rect SDL_Surface const SDL_Rect return SDL_Surface SDL_Rect SDL_Surface SDL_Rect return SDL_Thread return SDL_Thread return SDL_Thread int return SDL_TLSID const void void(*) return return Uint32 SDL_TimerID return int return SDL_TouchID int return return return const char return return int return int return int SDL_DisplayMode return int const SDL_DisplayMode SDL_DisplayMode return SDL_Window const SDL_DisplayMode return SDL_Window return const void return Uint32 return SDL_Window const char SDL_Window SDL_Surface SDL_Window const char return SDL_Window int int SDL_Window int int SDL_Window int int SDL_Window int int SDL_Window SDL_Window SDL_Window SDL_Window Uint32 return SDL_Window return SDL_Window SDL_bool SDL_Window float return SDL_Window const Uint16 const Uint16 const Uint16 return SDL_Window const char return SDL_GLattr int return SDL_Window return return SDL_Window int int return SDL_GLContext SDL_RWops int return return void return int int return double return SDL_bool return int int return SDL_AudioDeviceID const void Uint32 return SDL_AudioDeviceID int float float float return SDL_JoystickID

This is a unique ID for a joystick for the time it is connected to the system, and is never reused for the lifetime of the application. If the joystick is disconnected and reconnected, it will get a new ID.

The ID value starts at 0 and increments from there. The value -1 is an invalid ID.

Definition at line 81 of file SDL_joystick.h.

## Enumeration Type Documentation

## SDL_JoystickPowerLevel

enum SDL_JoystickPowerLevel

Enumerator
SDL_JOYSTICK_POWER_UNKNOWN |
SDL_JOYSTICK_POWER_EMPTY |
SDL_JOYSTICK_POWER_LOW |
SDL_JOYSTICK_POWER_MEDIUM |
SDL_JOYSTICK_POWER_FULL |
SDL_JOYSTICK_POWER_WIRED |
SDL_JOYSTICK_POWER_MAX |

Definition at line 97 of file SDL_joystick.h.

{
SDL_JOYSTICK_POWER_UNKNOWN = -1,
SDL_JOYSTICK_POWER_EMPTY,
SDL_JOYSTICK_POWER_LOW,
SDL_JOYSTICK_POWER_MEDIUM,
SDL_JOYSTICK_POWER_FULL,
SDL_JOYSTICK_POWER_WIRED,
SDL_JOYSTICK_POWER_MAX
} SDL_JoystickPowerLevel;
SDL_JOYSTICK_POWER_LOW
Definition: SDL_joystick.h:101
SDL_JOYSTICK_POWER_EMPTY
Definition: SDL_joystick.h:100
SDL_JOYSTICK_POWER_MAX
Definition: SDL_joystick.h:105
SDL_JOYSTICK_POWER_UNKNOWN
Definition: SDL_joystick.h:99
SDL_JoystickPowerLevel
SDL_JoystickPowerLevel
Definition: SDL_joystick.h:97
SDL_JOYSTICK_POWER_WIRED
Definition: SDL_joystick.h:104
SDL_JOYSTICK_POWER_MEDIUM
Definition: SDL_joystick.h:102
SDL_JOYSTICK_POWER_FULL
Definition: SDL_joystick.h:103

## SDL_JoystickType

enum SDL_JoystickType

Enumerator
SDL_JOYSTICK_TYPE_UNKNOWN |
SDL_JOYSTICK_TYPE_GAMECONTROLLER |
SDL_JOYSTICK_TYPE_WHEEL |
SDL_JOYSTICK_TYPE_ARCADE_STICK |
SDL_JOYSTICK_TYPE_FLIGHT_STICK |
SDL_JOYSTICK_TYPE_DANCE_PAD |
SDL_JOYSTICK_TYPE_GUITAR |
SDL_JOYSTICK_TYPE_DRUM_KIT |
SDL_JOYSTICK_TYPE_ARCADE_PAD |
SDL_JOYSTICK_TYPE_THROTTLE |

Definition at line 83 of file SDL_joystick.h.

{
SDL_JOYSTICK_TYPE_UNKNOWN,
SDL_JOYSTICK_TYPE_GAMECONTROLLER,
SDL_JOYSTICK_TYPE_WHEEL,
SDL_JOYSTICK_TYPE_ARCADE_STICK,
SDL_JOYSTICK_TYPE_FLIGHT_STICK,
SDL_JOYSTICK_TYPE_DANCE_PAD,
SDL_JOYSTICK_TYPE_GUITAR,
SDL_JOYSTICK_TYPE_DRUM_KIT,
SDL_JOYSTICK_TYPE_ARCADE_PAD,
SDL_JOYSTICK_TYPE_THROTTLE
} SDL_JoystickType;
SDL_JOYSTICK_TYPE_WHEEL
Definition: SDL_joystick.h:87
SDL_JOYSTICK_TYPE_DRUM_KIT
Definition: SDL_joystick.h:92
SDL_JOYSTICK_TYPE_ARCADE_PAD
Definition: SDL_joystick.h:93
SDL_JOYSTICK_TYPE_GUITAR
Definition: SDL_joystick.h:91
SDL_JOYSTICK_TYPE_FLIGHT_STICK
Definition: SDL_joystick.h:89
SDL_JOYSTICK_TYPE_DANCE_PAD
Definition: SDL_joystick.h:90
SDL_JOYSTICK_TYPE_ARCADE_STICK
Definition: SDL_joystick.h:88
SDL_JoystickType
SDL_JoystickType
Definition: SDL_joystick.h:83
SDL_JOYSTICK_TYPE_THROTTLE
Definition: SDL_joystick.h:94
SDL_JOYSTICK_TYPE_GAMECONTROLLER
Definition: SDL_joystick.h:86
SDL_JOYSTICK_TYPE_UNKNOWN
Definition: SDL_joystick.h:85

## Function Documentation

## SDL_JoystickClose()

void SDL_JoystickClose | ( | SDL_Joystick * | joystick | ) |

Close a joystick previously opened with SDL_JoystickOpen().

Definition at line 491 of file SDL_joystick.c.

References NULL, SDL_free, SDL_joysticks, SDL_LockJoysticks(), SDL_SYS_JoystickClose(), SDL_UnlockJoysticks(), and SDL_updating_joystick.

Referenced by SDL_JoystickOpen(), SDL_JoystickQuit(), and SDL_JoystickUpdate().

{
SDL_Joystick *joysticklist;
SDL_Joystick *joysticklistprev;
if (!joystick) {
return;
}
SDL_LockJoysticks();
/* First decrement ref count */
if (--joystick->ref_count > 0) {
SDL_UnlockJoysticks();
return;
}
if (SDL_updating_joystick) {
SDL_UnlockJoysticks();
return;
}
SDL_SYS_JoystickClose(joystick);
joystick->hwdata = NULL;
joysticklist = SDL_joysticks;
joysticklistprev = NULL;
while (joysticklist) {
if (joystick == joysticklist) {
if (joysticklistprev) {
/* unlink this entry */
joysticklistprev->next = joysticklist->next;
} else {
SDL_joysticks = joystick->next;
}
break;
}
joysticklistprev = joysticklist;
joysticklist = joysticklist->next;
}
SDL_free(joystick->name);
/* Free the data associated with this joystick */
SDL_free(joystick->axes);
SDL_free(joystick->hats);
SDL_free(joystick->balls);
SDL_free(joystick->buttons);
SDL_free(joystick);
SDL_UnlockJoysticks();
}
SDL_LockJoysticks
void SDL_LockJoysticks(void)
Definition: SDL_joystick.c:43
SDL_free
#define SDL_free
Definition: SDL_dynapi_overrides.h:377
SDL_UnlockJoysticks
void SDL_UnlockJoysticks(void)
Definition: SDL_joystick.c:51
NULL
#define NULL
Definition: begin_code.h:164
SDL_SYS_JoystickClose
void SDL_SYS_JoystickClose(SDL_Joystick *joystick)
Definition: SDL_sysjoystick.m:704
SDL_updating_joystick
static SDL_bool SDL_updating_joystick
Definition: SDL_joystick.c:39
SDL_joysticks
static SDL_Joystick * SDL_joysticks
Definition: SDL_joystick.c:38

## SDL_JoystickCurrentPowerLevel()

SDL_JoystickPowerLevel SDL_JoystickCurrentPowerLevel | ( | SDL_Joystick * | joystick | ) |

Return the battery level of this joystick

Definition at line 1268 of file SDL_joystick.c.

References SDL_JOYSTICK_POWER_UNKNOWN, and SDL_PrivateJoystickValid().

{
if (!SDL_PrivateJoystickValid(joystick)) {
return (SDL_JOYSTICK_POWER_UNKNOWN);
}
return joystick->epowerlevel;
}
SDL_PrivateJoystickValid
int SDL_PrivateJoystickValid(SDL_Joystick *joystick)
Definition: SDL_joystick.c:259
SDL_JOYSTICK_POWER_UNKNOWN
Definition: SDL_joystick.h:99

## SDL_JoystickEventState()

int SDL_JoystickEventState | ( | int | state | ) |

Enable/disable joystick event polling.

If joystick events are disabled, you must call SDL_JoystickUpdate() yourself and check the state of the joystick when you want joystick information.

The state can be one of SDL_QUERY, SDL_ENABLE or SDL_IGNORE.

Definition at line 902 of file SDL_joystick.c.

References i, SDL_arraysize, SDL_DISABLE, SDL_ENABLE, SDL_EventState, SDL_JOYAXISMOTION, SDL_JOYBALLMOTION, SDL_JOYBUTTONDOWN, SDL_JOYBUTTONUP, SDL_JOYDEVICEADDED, SDL_JOYDEVICEREMOVED, SDL_JOYHATMOTION, and SDL_QUERY.

{
#if SDL_EVENTS_DISABLED
return SDL_DISABLE;
#else
const Uint32 event_list[] = {
SDL_JOYAXISMOTION, SDL_JOYBALLMOTION, SDL_JOYHATMOTION,
SDL_JOYBUTTONDOWN, SDL_JOYBUTTONUP, SDL_JOYDEVICEADDED, SDL_JOYDEVICEREMOVED
};
unsigned int i;
switch (state) {
case SDL_QUERY:
state = SDL_DISABLE;
for (i = 0; i < SDL_arraysize(event_list); ++i) {
state = SDL_EventState(event_list[i], SDL_QUERY);
if (state == SDL_ENABLE) {
break;
}
}
break;
default:
for (i = 0; i < SDL_arraysize(event_list); ++i) {
SDL_EventState(event_list[i], state);
}
break;
}
return (state);
#endif /* SDL_EVENTS_DISABLED */
}
SDL_JOYBUTTONUP
Definition: SDL_events.h:112
SDL_JOYHATMOTION
Definition: SDL_events.h:110
SDL_JOYDEVICEADDED
Definition: SDL_events.h:113
state
struct xkb_state * state
Definition: SDL_waylandsym.h:113
SDL_ENABLE
#define SDL_ENABLE
Definition: SDL_events.h:722
SDL_JOYBALLMOTION
Definition: SDL_events.h:109
Uint32
uint32_t Uint32
Definition: SDL_stdinc.h:181
SDL_JOYAXISMOTION
Definition: SDL_events.h:108
SDL_JOYDEVICEREMOVED
Definition: SDL_events.h:114
SDL_JOYBUTTONDOWN
Definition: SDL_events.h:111
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
SDL_DISABLE
#define SDL_DISABLE
Definition: SDL_events.h:721
SDL_EventState
#define SDL_EventState
Definition: SDL_dynapi_overrides.h:131
SDL_arraysize
#define SDL_arraysize(array)
Definition: SDL_stdinc.h:93
SDL_QUERY
#define SDL_QUERY
Definition: SDL_events.h:719

## SDL_JoystickFromInstanceID()

SDL_Joystick* SDL_JoystickFromInstanceID | ( | SDL_JoystickID | joyid | ) |

Return the SDL_Joystick associated with an instance id.

Definition at line 459 of file SDL_joystick.c.

References NULL, SDL_joysticks, SDL_LockJoysticks(), and SDL_UnlockJoysticks().

{
SDL_Joystick *joystick;
SDL_LockJoysticks();
for (joystick = SDL_joysticks; joystick; joystick = joystick->next) {
if (joystick->instance_id == joyid) {
SDL_UnlockJoysticks();
return joystick;
}
}
SDL_UnlockJoysticks();
return NULL;
}
SDL_LockJoysticks
void SDL_LockJoysticks(void)
Definition: SDL_joystick.c:43
SDL_UnlockJoysticks
void SDL_UnlockJoysticks(void)
Definition: SDL_joystick.c:51
NULL
#define NULL
Definition: begin_code.h:164
SDL_joysticks
static SDL_Joystick * SDL_joysticks
Definition: SDL_joystick.c:38

## SDL_JoystickGetAttached()

SDL_bool SDL_JoystickGetAttached | ( | SDL_Joystick * | joystick | ) |

Returns SDL_TRUE if the joystick has been opened and currently connected, or SDL_FALSE if it has not.

Definition at line 433 of file SDL_joystick.c.

References SDL_FALSE, SDL_PrivateJoystickValid(), and SDL_SYS_JoystickAttached().

{
if (!SDL_PrivateJoystickValid(joystick)) {
return SDL_FALSE;
}
return SDL_SYS_JoystickAttached(joystick);
}
SDL_PrivateJoystickValid
int SDL_PrivateJoystickValid(SDL_Joystick *joystick)
Definition: SDL_joystick.c:259
SDL_FALSE
Definition: SDL_stdinc.h:141
SDL_SYS_JoystickAttached
SDL_bool SDL_SYS_JoystickAttached(SDL_Joystick *joystick)
Definition: SDL_sysjoystick.m:469

## SDL_JoystickGetAxis()

Sint16 SDL_JoystickGetAxis | ( | SDL_Joystick * | joystick,
|  | int | axis
| ) |  |

Get the current state of an axis control on a joystick.

The state is a value ranging from -32768 to 32767.

The axis indices start at index 0.

Definition at line 325 of file SDL_joystick.c.

References axis, SDL_PrivateJoystickValid(), SDL_SetError, and state.

{
Sint16 state;
if (!SDL_PrivateJoystickValid(joystick)) {
return (0);
}
if (axis < joystick->naxes) {
state = joystick->axes[axis].value;
} else {
SDL_SetError("Joystick only has %d axes", joystick->naxes);
state = 0;
}
return (state);
}
SDL_PrivateJoystickValid
int SDL_PrivateJoystickValid(SDL_Joystick *joystick)
Definition: SDL_joystick.c:259
state
struct xkb_state * state
Definition: SDL_waylandsym.h:113
axis
SDL_Texture * axis
Definition: testgamecontroller.c:67
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:30
Sint16
int16_t Sint16
Definition: SDL_stdinc.h:163

## SDL_JoystickGetAxisInitialState()

SDL_bool SDL_JoystickGetAxisInitialState | ( | SDL_Joystick * | joystick,
|  | int | axis,
|  | Sint16 * | state
| ) |  |

Get the initial state of an axis control on a joystick.

The state is a value ranging from -32768 to 32767.

The axis indices start at index 0.

Returns
  SDL_TRUE if this axis has any initial value, or SDL_FALSE if not.

Definition at line 345 of file SDL_joystick.c.

References axis, SDL_FALSE, SDL_PrivateJoystickValid(), and SDL_SetError.

{
if (!SDL_PrivateJoystickValid(joystick)) {
return SDL_FALSE;
}
if (axis >= joystick->naxes) {
SDL_SetError("Joystick only has %d axes", joystick->naxes);
return SDL_FALSE;
}
if (state) {
*state = joystick->axes[axis].initial_value;
}
return joystick->axes[axis].has_initial_value;
}
SDL_PrivateJoystickValid
int SDL_PrivateJoystickValid(SDL_Joystick *joystick)
Definition: SDL_joystick.c:259
SDL_FALSE
Definition: SDL_stdinc.h:141
state
struct xkb_state * state
Definition: SDL_waylandsym.h:113
axis
SDL_Texture * axis
Definition: testgamecontroller.c:67
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:30

## SDL_JoystickGetBall()

int SDL_JoystickGetBall | ( | SDL_Joystick * | joystick,
|  | int | ball,
|  | int * | dx,
|  | int * | dy
| ) |  |

Get the ball axis change since the last poll.

Returns
  0, or -1 if you passed it invalid parameters.

The ball indices start at index 0.

Definition at line 384 of file SDL_joystick.c.

References retval, SDL_PrivateJoystickValid(), and SDL_SetError.

{
int retval;
if (!SDL_PrivateJoystickValid(joystick)) {
return (-1);
}
retval = 0;
if (ball < joystick->nballs) {
if (dx) {
*dx = joystick->balls[ball].dx;
}
if (dy) {
*dy = joystick->balls[ball].dy;
}
joystick->balls[ball].dx = 0;
joystick->balls[ball].dy = 0;
} else {
return SDL_SetError("Joystick only has %d balls", joystick->nballs);
}
return (retval);
}
SDL_PrivateJoystickValid
int SDL_PrivateJoystickValid(SDL_Joystick *joystick)
Definition: SDL_joystick.c:259
retval
SDL_bool retval
Definition: testgamecontroller.c:65
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:30

## SDL_JoystickGetButton()

Uint8 SDL_JoystickGetButton | ( | SDL_Joystick * | joystick,
|  | int | button
| ) |  |

Get the current state of a button on a joystick.

The button indices start at index 0.

Definition at line 412 of file SDL_joystick.c.

References button, SDL_PrivateJoystickValid(), SDL_SetError, and state.

{
Uint8 state;
if (!SDL_PrivateJoystickValid(joystick)) {
return (0);
}
if (button < joystick->nbuttons) {
state = joystick->buttons[button];
} else {
SDL_SetError("Joystick only has %d buttons", joystick->nbuttons);
state = 0;
}
return (state);
}
SDL_PrivateJoystickValid
int SDL_PrivateJoystickValid(SDL_Joystick *joystick)
Definition: SDL_joystick.c:259
button
SDL_Texture * button
Definition: testgamecontroller.c:67
state
struct xkb_state * state
Definition: SDL_waylandsym.h:113
Uint8
uint8_t Uint8
Definition: SDL_stdinc.h:157
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:30

## SDL_JoystickGetDeviceGUID()

SDL_JoystickGUID SDL_JoystickGetDeviceGUID | ( | int | device_index | ) |

Return the GUID for the joystick at this index This can be called before any joysticks are opened.

Definition at line 1078 of file SDL_joystick.c.

References SDL_NumJoysticks(), SDL_SetError, SDL_SYS_JoystickGetDeviceGUID(), and SDL_zero.

Referenced by SDL_JoystickGetDeviceProduct(), SDL_JoystickGetDeviceProductVersion(), SDL_JoystickGetDeviceType(), and SDL_JoystickGetDeviceVendor().

{
if (device_index < 0 || device_index >= SDL_NumJoysticks()) {
SDL_JoystickGUID emptyGUID;
SDL_SetError("There are %d joysticks available", SDL_NumJoysticks());
SDL_zero(emptyGUID);
return emptyGUID;
}
return SDL_SYS_JoystickGetDeviceGUID(device_index);
}
SDL_NumJoysticks
int SDL_NumJoysticks(void)
Definition: SDL_joystick.c:102
SDL_zero
#define SDL_zero(x)
Definition: SDL_stdinc.h:416
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:30
SDL_JoystickGUID
Definition: SDL_joystick.h:70
SDL_SYS_JoystickGetDeviceGUID
SDL_JoystickGUID SDL_SYS_JoystickGetDeviceGUID(int device_index)
Definition: SDL_sysjoystick.m:771

## SDL_JoystickGetDeviceInstanceID()

SDL_JoystickID SDL_JoystickGetDeviceInstanceID | ( | int | device_index | ) |

Get the instance ID of a joystick. This can be called before any joysticks are opened. If the index is out of range, this function will return -1.

Definition at line 1130 of file SDL_joystick.c.

References SDL_NumJoysticks(), SDL_SetError, and SDL_SYS_GetInstanceIdOfDeviceIndex().

Referenced by SDL_JoystickOpen().

{
if (device_index < 0 || device_index >= SDL_NumJoysticks()) {
SDL_SetError("There are %d joysticks available", SDL_NumJoysticks());
return -1;
}
return SDL_SYS_GetInstanceIdOfDeviceIndex(device_index);
}
SDL_NumJoysticks
int SDL_NumJoysticks(void)
Definition: SDL_joystick.c:102
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:30
SDL_SYS_GetInstanceIdOfDeviceIndex
SDL_JoystickID SDL_SYS_GetInstanceIdOfDeviceIndex(int device_index)
Definition: SDL_sysjoystick.m:409

## SDL_JoystickGetDeviceProduct()

Uint16 SDL_JoystickGetDeviceProduct | ( | int | device_index | ) |

Get the USB product ID of a joystick, if available. This can be called before any joysticks are opened. If the product ID isn't available this function returns 0.

Definition at line 1098 of file SDL_joystick.c.

References NULL, SDL_GetJoystickGUIDInfo(), and SDL_JoystickGetDeviceGUID().

{
Uint16 product;
SDL_JoystickGUID guid = SDL_JoystickGetDeviceGUID(device_index);
SDL_GetJoystickGUIDInfo(guid, NULL, &product, NULL);
return product;
}
SDL_JoystickGetDeviceGUID
SDL_JoystickGUID SDL_JoystickGetDeviceGUID(int device_index)
Definition: SDL_joystick.c:1078
NULL
#define NULL
Definition: begin_code.h:164
SDL_GetJoystickGUIDInfo
void SDL_GetJoystickGUIDInfo(SDL_JoystickGUID guid, Uint16 *vendor, Uint16 *product, Uint16 *version)
Definition: SDL_joystick.c:933
SDL_JoystickGUID
Definition: SDL_joystick.h:70
Uint16
uint16_t Uint16
Definition: SDL_stdinc.h:169

## SDL_JoystickGetDeviceProductVersion()

Uint16 SDL_JoystickGetDeviceProductVersion | ( | int | device_index | ) |

Get the product version of a joystick, if available. This can be called before any joysticks are opened. If the product version isn't available this function returns 0.

Definition at line 1107 of file SDL_joystick.c.

References NULL, SDL_GetJoystickGUIDInfo(), and SDL_JoystickGetDeviceGUID().

{
Uint16 version;
SDL_JoystickGUID guid = SDL_JoystickGetDeviceGUID(device_index);
SDL_GetJoystickGUIDInfo(guid, NULL, NULL, &version);
return version;
}
SDL_JoystickGetDeviceGUID
SDL_JoystickGUID SDL_JoystickGetDeviceGUID(int device_index)
Definition: SDL_joystick.c:1078
NULL
#define NULL
Definition: begin_code.h:164
SDL_GetJoystickGUIDInfo
void SDL_GetJoystickGUIDInfo(SDL_JoystickGUID guid, Uint16 *vendor, Uint16 *product, Uint16 *version)
Definition: SDL_joystick.c:933
SDL_JoystickGUID
Definition: SDL_joystick.h:70
Uint16
uint16_t Uint16
Definition: SDL_stdinc.h:169

## SDL_JoystickGetDeviceType()

SDL_JoystickType SDL_JoystickGetDeviceType | ( | int | device_index | ) |

Get the type of a joystick, if available. This can be called before any joysticks are opened.

Definition at line 1116 of file SDL_joystick.c.

References SDL_GetJoystickGUIDType(), SDL_IsGameController, SDL_JOYSTICK_TYPE_GAMECONTROLLER, SDL_JOYSTICK_TYPE_UNKNOWN, and SDL_JoystickGetDeviceGUID().

{
SDL_JoystickType type;
SDL_JoystickGUID guid = SDL_JoystickGetDeviceGUID(device_index);
type = SDL_GetJoystickGUIDType(guid);
if (type == SDL_JOYSTICK_TYPE_UNKNOWN) {
if (SDL_IsGameController(device_index)) {
type = SDL_JOYSTICK_TYPE_GAMECONTROLLER;
}
}
return type;
}
SDL_IsGameController
#define SDL_IsGameController
Definition: SDL_dynapi_overrides.h:138
SDL_JoystickType
SDL_JoystickType
Definition: SDL_joystick.h:83
SDL_JoystickGetDeviceGUID
SDL_JoystickGUID SDL_JoystickGetDeviceGUID(int device_index)
Definition: SDL_joystick.c:1078
SDL_JOYSTICK_TYPE_GAMECONTROLLER
Definition: SDL_joystick.h:86
SDL_JoystickGUID
Definition: SDL_joystick.h:70
type
GLuint GLuint GLsizei GLenum type
Definition: SDL_opengl.h:1571
SDL_JOYSTICK_TYPE_UNKNOWN
Definition: SDL_joystick.h:85
SDL_GetJoystickGUIDType
static SDL_JoystickType SDL_GetJoystickGUIDType(SDL_JoystickGUID guid)
Definition: SDL_joystick.c:1027

## SDL_JoystickGetDeviceVendor()

Uint16 SDL_JoystickGetDeviceVendor | ( | int | device_index | ) |

Get the USB vendor ID of a joystick, if available. This can be called before any joysticks are opened. If the vendor ID isn't available this function returns 0.

Definition at line 1089 of file SDL_joystick.c.

References NULL, SDL_GetJoystickGUIDInfo(), and SDL_JoystickGetDeviceGUID().

{
Uint16 vendor;
SDL_JoystickGUID guid = SDL_JoystickGetDeviceGUID(device_index);
SDL_GetJoystickGUIDInfo(guid, &vendor, NULL, NULL);
return vendor;
}
SDL_JoystickGetDeviceGUID
SDL_JoystickGUID SDL_JoystickGetDeviceGUID(int device_index)
Definition: SDL_joystick.c:1078
NULL
#define NULL
Definition: begin_code.h:164
SDL_GetJoystickGUIDInfo
void SDL_GetJoystickGUIDInfo(SDL_JoystickGUID guid, Uint16 *vendor, Uint16 *product, Uint16 *version)
Definition: SDL_joystick.c:933
SDL_JoystickGUID
Definition: SDL_joystick.h:70
Uint16
uint16_t Uint16
Definition: SDL_stdinc.h:169

## SDL_JoystickGetGUID()

SDL_JoystickGUID SDL_JoystickGetGUID | ( | SDL_Joystick * | joystick | ) |

Return the GUID for this opened joystick

Definition at line 1139 of file SDL_joystick.c.

References SDL_PrivateJoystickValid(), SDL_SYS_JoystickGetGUID(), and SDL_zero.

Referenced by SDL_JoystickGetProduct(), SDL_JoystickGetProductVersion(), SDL_JoystickGetType(), and SDL_JoystickGetVendor().

{
if (!SDL_PrivateJoystickValid(joystick)) {
SDL_JoystickGUID emptyGUID;
SDL_zero(emptyGUID);
return emptyGUID;
}
return SDL_SYS_JoystickGetGUID(joystick);
}
SDL_PrivateJoystickValid
int SDL_PrivateJoystickValid(SDL_Joystick *joystick)
Definition: SDL_joystick.c:259
SDL_zero
#define SDL_zero(x)
Definition: SDL_stdinc.h:416
SDL_SYS_JoystickGetGUID
SDL_JoystickGUID SDL_SYS_JoystickGetGUID(SDL_Joystick *joystick)
Definition: SDL_sysjoystick.m:784
SDL_JoystickGUID
Definition: SDL_joystick.h:70

## SDL_JoystickGetGUIDFromString()

SDL_JoystickGUID SDL_JoystickGetGUIDFromString | ( | const char * | pchGUID | ) |

Convert a string into a joystick guid

Definition at line 1238 of file SDL_joystick.c.

References i, nibble(), SDL_memset, and SDL_strlen.

{
SDL_JoystickGUID guid;
int maxoutputbytes= sizeof(guid);
size_t len = SDL_strlen(pchGUID);
Uint8 *p;
size_t i;
/* Make sure it's even */
len = (len) & ~0x1;
SDL_memset(&guid, 0x00, sizeof(guid));
p = (Uint8 *)&guid;
for (i = 0; (i < len) && ((p - (Uint8 *)&guid) < maxoutputbytes); i+=2, p++) {
*p = (nibble(pchGUID[i]) << 4) | nibble(pchGUID[i+1]);
}
return guid;
}
x1
GLuint GLfloat GLfloat GLfloat x1
Definition: SDL_opengl_glext.h:8583
p
GLfloat GLfloat p
Definition: SDL_opengl_glext.h:11090
len
GLenum GLsizei len
Definition: SDL_opengl_glext.h:2926
Uint8
uint8_t Uint8
Definition: SDL_stdinc.h:157
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
nibble
static unsigned char nibble(char c)
Definition: SDL_joystick.c:1217
SDL_strlen
#define SDL_strlen
Definition: SDL_dynapi_overrides.h:393
SDL_JoystickGUID
Definition: SDL_joystick.h:70
SDL_memset
#define SDL_memset
Definition: SDL_dynapi_overrides.h:386

## SDL_JoystickGetGUIDString()

void SDL_JoystickGetGUIDString | ( | SDL_JoystickGUID | guid,
|  | char * | pszGUID,
|  | int | cbGUID
| ) |  |

Return a string representation for this guid. pszGUID must point to at least 33 bytes (32 for the string plus a NULL terminator).

Definition at line 1191 of file SDL_joystick.c.

References SDL_JoystickGUID::data, i, and NULL.

{
static const char k_rgchHexToASCII[] = "0123456789abcdef";
int i;
if ((pszGUID == NULL) || (cbGUID <= 0)) {
return;
}
for (i = 0; i < sizeof(guid.data) && i < (cbGUID-1)/2; i++) {
/* each input byte writes 2 ascii chars, and might write a null byte. */
/* If we don't have room for next input byte, stop */
unsigned char c = guid.data[i];
*pszGUID++ = k_rgchHexToASCII[c >> 4];
*pszGUID++ = k_rgchHexToASCII[c & 0x0F];
}
*pszGUID = '\0';
}
SDL_JoystickGUID::data
Uint8 data[16]
Definition: SDL_joystick.h:71
c
const GLubyte * c
Definition: SDL_opengl_glext.h:11093
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
NULL
#define NULL
Definition: begin_code.h:164

## SDL_JoystickGetHat()

Uint8 SDL_JoystickGetHat | ( | SDL_Joystick * | joystick,
|  | int | hat
| ) |  |

Get the current state of a POV hat on a joystick.

The hat indices start at index 0.

Returns
  The return value is one of the following positions:
  - SDL_HAT_CENTERED
  - SDL_HAT_UP
  - SDL_HAT_RIGHT
  - SDL_HAT_DOWN
  - SDL_HAT_LEFT
  - SDL_HAT_RIGHTUP
  - SDL_HAT_RIGHTDOWN
  - SDL_HAT_LEFTUP
  - SDL_HAT_LEFTDOWN

Definition at line 364 of file SDL_joystick.c.

References SDL_PrivateJoystickValid(), SDL_SetError, and state.

{
Uint8 state;
if (!SDL_PrivateJoystickValid(joystick)) {
return (0);
}
if (hat < joystick->nhats) {
state = joystick->hats[hat];
} else {
SDL_SetError("Joystick only has %d hats", joystick->nhats);
state = 0;
}
return (state);
}
SDL_PrivateJoystickValid
int SDL_PrivateJoystickValid(SDL_Joystick *joystick)
Definition: SDL_joystick.c:259
state
struct xkb_state * state
Definition: SDL_waylandsym.h:113
Uint8
uint8_t Uint8
Definition: SDL_stdinc.h:157
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:30

## SDL_JoystickGetProduct()

Uint16 SDL_JoystickGetProduct | ( | SDL_Joystick * | joystick | ) |

Get the USB product ID of an opened joystick, if available. If the product ID isn't available this function returns 0.

Definition at line 1158 of file SDL_joystick.c.

References NULL, SDL_GetJoystickGUIDInfo(), and SDL_JoystickGetGUID().

Referenced by SDL_JoystickAxesCenteredAtZero().

{
Uint16 product;
SDL_JoystickGUID guid = SDL_JoystickGetGUID(joystick);
SDL_GetJoystickGUIDInfo(guid, NULL, &product, NULL);
return product;
}
SDL_JoystickGetGUID
SDL_JoystickGUID SDL_JoystickGetGUID(SDL_Joystick *joystick)
Definition: SDL_joystick.c:1139
NULL
#define NULL
Definition: begin_code.h:164
SDL_GetJoystickGUIDInfo
void SDL_GetJoystickGUIDInfo(SDL_JoystickGUID guid, Uint16 *vendor, Uint16 *product, Uint16 *version)
Definition: SDL_joystick.c:933
SDL_JoystickGUID
Definition: SDL_joystick.h:70
Uint16
uint16_t Uint16
Definition: SDL_stdinc.h:169

## SDL_JoystickGetProductVersion()

Uint16 SDL_JoystickGetProductVersion | ( | SDL_Joystick * | joystick | ) |

Get the product version of an opened joystick, if available. If the product version isn't available this function returns 0.

Definition at line 1167 of file SDL_joystick.c.

References NULL, SDL_GetJoystickGUIDInfo(), and SDL_JoystickGetGUID().

{
Uint16 version;
SDL_JoystickGUID guid = SDL_JoystickGetGUID(joystick);
SDL_GetJoystickGUIDInfo(guid, NULL, NULL, &version);
return version;
}
SDL_JoystickGetGUID
SDL_JoystickGUID SDL_JoystickGetGUID(SDL_Joystick *joystick)
Definition: SDL_joystick.c:1139
NULL
#define NULL
Definition: begin_code.h:164
SDL_GetJoystickGUIDInfo
void SDL_GetJoystickGUIDInfo(SDL_JoystickGUID guid, Uint16 *vendor, Uint16 *product, Uint16 *version)
Definition: SDL_joystick.c:933
SDL_JoystickGUID
Definition: SDL_joystick.h:70
Uint16
uint16_t Uint16
Definition: SDL_stdinc.h:169

## SDL_JoystickGetType()

SDL_JoystickType SDL_JoystickGetType | ( | SDL_Joystick * | joystick | ) |

Get the type of an opened joystick.

Definition at line 1176 of file SDL_joystick.c.

References SDL_GetJoystickGUIDType(), SDL_JOYSTICK_TYPE_GAMECONTROLLER, SDL_JOYSTICK_TYPE_UNKNOWN, and SDL_JoystickGetGUID().

{
SDL_JoystickType type;
SDL_JoystickGUID guid = SDL_JoystickGetGUID(joystick);
type = SDL_GetJoystickGUIDType(guid);
if (type == SDL_JOYSTICK_TYPE_UNKNOWN) {
if (joystick && joystick->is_game_controller) {
type = SDL_JOYSTICK_TYPE_GAMECONTROLLER;
}
}
return type;
}
SDL_JoystickGetGUID
SDL_JoystickGUID SDL_JoystickGetGUID(SDL_Joystick *joystick)
Definition: SDL_joystick.c:1139
SDL_JoystickType
SDL_JoystickType
Definition: SDL_joystick.h:83
SDL_JOYSTICK_TYPE_GAMECONTROLLER
Definition: SDL_joystick.h:86
SDL_JoystickGUID
Definition: SDL_joystick.h:70
type
GLuint GLuint GLsizei GLenum type
Definition: SDL_opengl.h:1571
SDL_JOYSTICK_TYPE_UNKNOWN
Definition: SDL_joystick.h:85
SDL_GetJoystickGUIDType
static SDL_JoystickType SDL_GetJoystickGUIDType(SDL_JoystickGUID guid)
Definition: SDL_joystick.c:1027

## SDL_JoystickGetVendor()

Uint16 SDL_JoystickGetVendor | ( | SDL_Joystick * | joystick | ) |

Get the USB vendor ID of an opened joystick, if available. If the vendor ID isn't available this function returns 0.

Definition at line 1149 of file SDL_joystick.c.

References NULL, SDL_GetJoystickGUIDInfo(), and SDL_JoystickGetGUID().

Referenced by SDL_JoystickAxesCenteredAtZero().

{
Uint16 vendor;
SDL_JoystickGUID guid = SDL_JoystickGetGUID(joystick);
SDL_GetJoystickGUIDInfo(guid, &vendor, NULL, NULL);
return vendor;
}
SDL_JoystickGetGUID
SDL_JoystickGUID SDL_JoystickGetGUID(SDL_Joystick *joystick)
Definition: SDL_joystick.c:1139
NULL
#define NULL
Definition: begin_code.h:164
SDL_GetJoystickGUIDInfo
void SDL_GetJoystickGUIDInfo(SDL_JoystickGUID guid, Uint16 *vendor, Uint16 *product, Uint16 *version)
Definition: SDL_joystick.c:933
SDL_JoystickGUID
Definition: SDL_joystick.h:70
Uint16
uint16_t Uint16
Definition: SDL_stdinc.h:169

## SDL_JoystickInstanceID()

SDL_JoystickID SDL_JoystickInstanceID | ( | SDL_Joystick * | joystick | ) |

Get the instance ID of an opened joystick or -1 if the joystick is invalid.

Definition at line 446 of file SDL_joystick.c.

References SDL_PrivateJoystickValid().

{
if (!SDL_PrivateJoystickValid(joystick)) {
return (-1);
}
return (joystick->instance_id);
}
SDL_PrivateJoystickValid
int SDL_PrivateJoystickValid(SDL_Joystick *joystick)
Definition: SDL_joystick.c:259

## SDL_JoystickName()

const char* SDL_JoystickName | ( | SDL_Joystick * | joystick | ) |

Return the name for this currently opened joystick. If no name can be found, this function returns NULL.

Definition at line 478 of file SDL_joystick.c.

References NULL, and SDL_PrivateJoystickValid().

{
if (!SDL_PrivateJoystickValid(joystick)) {
return (NULL);
}
return (joystick->name);
}
SDL_PrivateJoystickValid
int SDL_PrivateJoystickValid(SDL_Joystick *joystick)
Definition: SDL_joystick.c:259
NULL
#define NULL
Definition: begin_code.h:164

## SDL_JoystickNameForIndex()

const char* SDL_JoystickNameForIndex | ( | int | device_index | ) |

Get the implementation dependent name of a joystick. This can be called before any joysticks are opened. If no name can be found, this function returns NULL.

Definition at line 111 of file SDL_joystick.c.

References NULL, SDL_NumJoysticks(), SDL_SetError, and SDL_SYS_JoystickNameForDeviceIndex().

{
if (device_index < 0 || device_index >= SDL_NumJoysticks()) {
SDL_SetError("There are %d joysticks available", SDL_NumJoysticks());
return (NULL);
}
return (SDL_SYS_JoystickNameForDeviceIndex(device_index));
}
SDL_NumJoysticks
int SDL_NumJoysticks(void)
Definition: SDL_joystick.c:102
SDL_SYS_JoystickNameForDeviceIndex
const char * SDL_SYS_JoystickNameForDeviceIndex(int device_index)
Definition: SDL_sysjoystick.m:402
NULL
#define NULL
Definition: begin_code.h:164
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:30

## SDL_JoystickNumAxes()

int SDL_JoystickNumAxes | ( | SDL_Joystick * | joystick | ) |

Get the number of general axis controls on a joystick.

Definition at line 277 of file SDL_joystick.c.

References SDL_PrivateJoystickValid().

{
if (!SDL_PrivateJoystickValid(joystick)) {
return (-1);
}
return (joystick->naxes);
}
SDL_PrivateJoystickValid
int SDL_PrivateJoystickValid(SDL_Joystick *joystick)
Definition: SDL_joystick.c:259

## SDL_JoystickNumBalls()

int SDL_JoystickNumBalls | ( | SDL_Joystick * | joystick | ) |

Get the number of trackballs on a joystick.

Joystick trackballs have only relative motion events associated with them and their state cannot be polled.

Definition at line 301 of file SDL_joystick.c.

References SDL_PrivateJoystickValid().

{
if (!SDL_PrivateJoystickValid(joystick)) {
return (-1);
}
return (joystick->nballs);
}
SDL_PrivateJoystickValid
int SDL_PrivateJoystickValid(SDL_Joystick *joystick)
Definition: SDL_joystick.c:259

## SDL_JoystickNumButtons()

int SDL_JoystickNumButtons | ( | SDL_Joystick * | joystick | ) |

Get the number of buttons on a joystick.

Definition at line 313 of file SDL_joystick.c.

References SDL_PrivateJoystickValid().

{
if (!SDL_PrivateJoystickValid(joystick)) {
return (-1);
}
return (joystick->nbuttons);
}
SDL_PrivateJoystickValid
int SDL_PrivateJoystickValid(SDL_Joystick *joystick)
Definition: SDL_joystick.c:259

## SDL_JoystickNumHats()

int SDL_JoystickNumHats | ( | SDL_Joystick * | joystick | ) |

Get the number of POV hats on a joystick.

Definition at line 289 of file SDL_joystick.c.

References SDL_PrivateJoystickValid().

{
if (!SDL_PrivateJoystickValid(joystick)) {
return (-1);
}
return (joystick->nhats);
}
SDL_PrivateJoystickValid
int SDL_PrivateJoystickValid(SDL_Joystick *joystick)
Definition: SDL_joystick.c:259

## SDL_JoystickOpen()

SDL_Joystick* SDL_JoystickOpen | ( | int | device_index | ) |

Open a joystick for use. The index passed as an argument refers to the N'th joystick on the system. This index is not the value which will identify this joystick in future joystick events. The joystick's instance id (SDL_JoystickID) will be used there instead.

Returns
  A joystick identifier, or NULL if an error occurred.

Definition at line 160 of file SDL_joystick.c.

References i, SDL_GameController::joystick, NULL, SDL_calloc, SDL_free, SDL_IsGameController, SDL_JOYSTICK_POWER_UNKNOWN, SDL_JoystickAxesCenteredAtZero(), SDL_JoystickClose(), SDL_JoystickGetDeviceInstanceID(), SDL_joysticks, SDL_LockJoysticks(), SDL_NumJoysticks(), SDL_OutOfMemory, SDL_SetError, SDL_strdup, SDL_SYS_JoystickNameForDeviceIndex(), SDL_SYS_JoystickOpen(), SDL_SYS_JoystickUpdate(), SDL_TRUE, and SDL_UnlockJoysticks().

{
SDL_Joystick *joystick;
SDL_Joystick *joysticklist;
const char *joystickname = NULL;
if ((device_index < 0) || (device_index >= SDL_NumJoysticks())) {
SDL_SetError("There are %d joysticks available", SDL_NumJoysticks());
return (NULL);
}
SDL_LockJoysticks();
joysticklist = SDL_joysticks;
/* If the joystick is already open, return it
* it is important that we have a single joystick * for each instance id
*/
while (joysticklist) {
if (SDL_JoystickGetDeviceInstanceID(device_index) == joysticklist->instance_id) {
joystick = joysticklist;
++joystick->ref_count;
SDL_UnlockJoysticks();
return (joystick);
}
joysticklist = joysticklist->next;
}
/* Create and initialize the joystick */
joystick = (SDL_Joystick *) SDL_calloc(sizeof(*joystick), 1);
if (joystick == NULL) {
SDL_OutOfMemory();
SDL_UnlockJoysticks();
return NULL;
}
if (SDL_SYS_JoystickOpen(joystick, device_index) < 0) {
SDL_free(joystick);
SDL_UnlockJoysticks();
return NULL;
}
joystickname = SDL_SYS_JoystickNameForDeviceIndex(device_index);
if (joystickname)
joystick->name = SDL_strdup(joystickname);
else
joystick->name = NULL;
if (joystick->naxes > 0) {
joystick->axes = (SDL_JoystickAxisInfo *) SDL_calloc(joystick->naxes, sizeof(SDL_JoystickAxisInfo));
}
if (joystick->nhats > 0) {
joystick->hats = (Uint8 *) SDL_calloc(joystick->nhats, sizeof(Uint8));
}
if (joystick->nballs > 0) {
joystick->balls = (struct balldelta *) SDL_calloc(joystick->nballs, sizeof(*joystick->balls));
}
if (joystick->nbuttons > 0) {
joystick->buttons = (Uint8 *) SDL_calloc(joystick->nbuttons, sizeof(Uint8));
}
if (((joystick->naxes > 0) && !joystick->axes)
|| ((joystick->nhats > 0) && !joystick->hats)
|| ((joystick->nballs > 0) && !joystick->balls)
|| ((joystick->nbuttons > 0) && !joystick->buttons)) {
SDL_OutOfMemory();
SDL_JoystickClose(joystick);
SDL_UnlockJoysticks();
return NULL;
}
joystick->epowerlevel = SDL_JOYSTICK_POWER_UNKNOWN;
/* If this joystick is known to have all zero centered axes, skip the auto-centering code */
if (SDL_JoystickAxesCenteredAtZero(joystick)) {
int i;
for (i = 0; i < joystick->naxes; ++i) {
joystick->axes[i].has_initial_value = SDL_TRUE;
}
}
joystick->is_game_controller = SDL_IsGameController(device_index);
/* Add joystick to list */
++joystick->ref_count;
/* Link the joystick in the list */
joystick->next = SDL_joysticks;
SDL_joysticks = joystick;
SDL_UnlockJoysticks();
SDL_SYS_JoystickUpdate(joystick);
return (joystick);
}
SDL_LockJoysticks
void SDL_LockJoysticks(void)
Definition: SDL_joystick.c:43
SDL_TRUE
Definition: SDL_stdinc.h:142
SDL_JoystickClose
void SDL_JoystickClose(SDL_Joystick *joystick)
Definition: SDL_joystick.c:491
SDL_IsGameController
#define SDL_IsGameController
Definition: SDL_dynapi_overrides.h:138
SDL_JoystickAxisInfo
Definition: SDL_sysjoystick.h:32
SDL_NumJoysticks
int SDL_NumJoysticks(void)
Definition: SDL_joystick.c:102
Uint8
uint8_t Uint8
Definition: SDL_stdinc.h:157
SDL_free
#define SDL_free
Definition: SDL_dynapi_overrides.h:377
SDL_SYS_JoystickNameForDeviceIndex
const char * SDL_SYS_JoystickNameForDeviceIndex(int device_index)
Definition: SDL_sysjoystick.m:402
SDL_UnlockJoysticks
void SDL_UnlockJoysticks(void)
Definition: SDL_joystick.c:51
SDL_JOYSTICK_POWER_UNKNOWN
Definition: SDL_joystick.h:99
SDL_SYS_JoystickUpdate
void SDL_SYS_JoystickUpdate(SDL_Joystick *joystick)
Definition: SDL_sysjoystick.m:682
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
SDL_JoystickGetDeviceInstanceID
SDL_JoystickID SDL_JoystickGetDeviceInstanceID(int device_index)
Definition: SDL_joystick.c:1130
NULL
#define NULL
Definition: begin_code.h:164
SDL_OutOfMemory
#define SDL_OutOfMemory()
Definition: SDL_error.h:52
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:30
SDL_calloc
#define SDL_calloc
Definition: SDL_dynapi_overrides.h:375
SDL_strdup
#define SDL_strdup
Definition: SDL_dynapi_overrides.h:397
SDL_JoystickAxesCenteredAtZero
static SDL_bool SDL_JoystickAxesCenteredAtZero(SDL_Joystick *joystick)
Definition: SDL_joystick.c:126
SDL_SYS_JoystickOpen
int SDL_SYS_JoystickOpen(SDL_Joystick *joystick, int device_index)
Definition: SDL_sysjoystick.m:421
SDL_joysticks
static SDL_Joystick * SDL_joysticks
Definition: SDL_joystick.c:38

## SDL_JoystickUpdate()

void SDL_JoystickUpdate | ( | void |  | ) |

Update the current state of the open joysticks.

This is called automatically by the event loop if any joystick events are enabled.

Definition at line 840 of file SDL_joystick.c.

References i, SDL_FALSE, SDL_HAT_CENTERED, SDL_JoystickClose(), SDL_joysticks, SDL_LockJoysticks(), SDL_PrivateJoystickAxis(), SDL_PrivateJoystickButton(), SDL_PrivateJoystickHat(), SDL_SYS_JoystickDetect(), SDL_SYS_JoystickUpdate(), SDL_TRUE, SDL_UnlockJoysticks(), and SDL_updating_joystick.

{
SDL_Joystick *joystick;
SDL_LockJoysticks();
if (SDL_updating_joystick) {
/* The joysticks are already being updated */
SDL_UnlockJoysticks();
return;
}
SDL_updating_joystick = SDL_TRUE;
/* Make sure the list is unlocked while dispatching events to prevent application deadlocks */
SDL_UnlockJoysticks();
for (joystick = SDL_joysticks; joystick; joystick = joystick->next) {
SDL_SYS_JoystickUpdate(joystick);
if (joystick->force_recentering) {
int i;
/* Tell the app that everything is centered/unpressed... */
for (i = 0; i < joystick->naxes; i++) {
if (joystick->axes[i].has_initial_value) {
SDL_PrivateJoystickAxis(joystick, i, joystick->axes[i].zero);
}
}
for (i = 0; i < joystick->nbuttons; i++) {
SDL_PrivateJoystickButton(joystick, i, 0);
}
for (i = 0; i < joystick->nhats; i++) {
SDL_PrivateJoystickHat(joystick, i, SDL_HAT_CENTERED);
}
joystick->force_recentering = SDL_FALSE;
}
}
SDL_LockJoysticks();
SDL_updating_joystick = SDL_FALSE;
/* If any joysticks were closed while updating, free them here */
for (joystick = SDL_joysticks; joystick; joystick = joystick->next) {
if (joystick->ref_count <= 0) {
SDL_JoystickClose(joystick);
}
}
/* this needs to happen AFTER walking the joystick list above, so that any
dangling hardware data from removed devices can be free'd
*/
SDL_SYS_JoystickDetect();
SDL_UnlockJoysticks();
}
SDL_LockJoysticks
void SDL_LockJoysticks(void)
Definition: SDL_joystick.c:43
SDL_TRUE
Definition: SDL_stdinc.h:142
SDL_JoystickClose
void SDL_JoystickClose(SDL_Joystick *joystick)
Definition: SDL_joystick.c:491
SDL_PrivateJoystickHat
int SDL_PrivateJoystickHat(SDL_Joystick *joystick, Uint8 hat, Uint8 value)
Definition: SDL_joystick.c:712
SDL_FALSE
Definition: SDL_stdinc.h:141
SDL_PrivateJoystickButton
int SDL_PrivateJoystickButton(SDL_Joystick *joystick, Uint8 button, Uint8 state)
Definition: SDL_joystick.c:788
SDL_PrivateJoystickAxis
int SDL_PrivateJoystickAxis(SDL_Joystick *joystick, Uint8 axis, Sint16 value)
Definition: SDL_joystick.c:655
SDL_UnlockJoysticks
void SDL_UnlockJoysticks(void)
Definition: SDL_joystick.c:51
SDL_SYS_JoystickUpdate
void SDL_SYS_JoystickUpdate(SDL_Joystick *joystick)
Definition: SDL_sysjoystick.m:682
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
SDL_HAT_CENTERED
#define SDL_HAT_CENTERED
Definition: SDL_joystick.h:316
SDL_updating_joystick
static SDL_bool SDL_updating_joystick
Definition: SDL_joystick.c:39
SDL_joysticks
static SDL_Joystick * SDL_joysticks
Definition: SDL_joystick.c:38
SDL_SYS_JoystickDetect
void SDL_SYS_JoystickDetect(void)
Definition: SDL_sysjoystick.m:395

## SDL_LockJoysticks()

void SDL_LockJoysticks | ( | void |  | ) |

Locking for multi-threaded access to the joystick API

If you are using the joystick API or handling events from multiple threads you should use these locking functions to protect access to the joysticks.

In particular, you are guaranteed that the joystick list won't change, so the API functions that take a joystick index will be valid, and joystick and game controller events will not be delivered.

Definition at line 43 of file SDL_joystick.c.

References SDL_LockMutex.

Referenced by SDL_JoystickClose(), SDL_JoystickFromInstanceID(), SDL_JoystickOpen(), SDL_JoystickQuit(), and SDL_JoystickUpdate().

{
if (SDL_joystick_lock) {
SDL_LockMutex(SDL_joystick_lock);
}
}
SDL_LockMutex
#define SDL_LockMutex
Definition: SDL_dynapi_overrides.h:260
SDL_joystick_lock
static SDL_mutex * SDL_joystick_lock
Definition: SDL_joystick.c:40

## SDL_NumJoysticks()

int SDL_NumJoysticks | ( | void |  | ) |

Count the number of joysticks attached to the system right now

Definition at line 102 of file SDL_joystick.c.

References SDL_SYS_NumJoysticks().

Referenced by SDL_JoystickGetDeviceGUID(), SDL_JoystickGetDeviceInstanceID(), SDL_JoystickNameForIndex(), and SDL_JoystickOpen().

{
return SDL_SYS_NumJoysticks();
}
SDL_SYS_NumJoysticks
int SDL_SYS_NumJoysticks(void)
Definition: SDL_sysjoystick.m:389

## SDL_UnlockJoysticks()

void SDL_UnlockJoysticks | ( | void |  | ) |

Definition at line 51 of file SDL_joystick.c.

References SDL_UnlockMutex, and SDLCALL.

Referenced by SDL_JoystickClose(), SDL_JoystickFromInstanceID(), SDL_JoystickOpen(), SDL_JoystickQuit(), and SDL_JoystickUpdate().

{
if (SDL_joystick_lock) {
SDL_UnlockMutex(SDL_joystick_lock);
}
}
SDL_joystick_lock
static SDL_mutex * SDL_joystick_lock
Definition: SDL_joystick.c:40
SDL_UnlockMutex
#define SDL_UnlockMutex
Definition: SDL_dynapi_overrides.h:262